'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _downloadjs = require('downloadjs');

var _downloadjs2 = _interopRequireDefault(_downloadjs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Json2Excel = function () {
  function Json2Excel(_ref) {
    var data = _ref.data,
        _ref$title = _ref.title,
        title = _ref$title === undefined ? 'title' : _ref$title,
        _ref$type = _ref.type,
        type = _ref$type === undefined ? 'xls' : _ref$type,
        _ref$fields = _ref.fields,
        fields = _ref$fields === undefined ? false : _ref$fields,
        _ref$exportFields = _ref.exportFields,
        exportFields = _ref$exportFields === undefined ? false : _ref$exportFields,
        _ref$name = _ref.name,
        name = _ref$name === undefined ? 'data.xls' : _ref$name,
        _ref$footer = _ref.footer,
        footer = _ref$footer === undefined ? null : _ref$footer;
    (0, _classCallCheck3.default)(this, Json2Excel);

    this.data = data;
    this.title = title;
    this.type = type;
    this.fields = fields;
    this.exportFields = exportFields;
    this.name = name;
    this.footer = footer;
  }

  (0, _createClass3.default)(Json2Excel, [{
    key: 'downloadFields',
    value: function downloadFields() {
      if (this.fields !== undefined) return this.fields;

      if (this.exportFields !== undefined) return this.exportFields;
    }
  }, {
    key: 'generate',
    value: function generate() {
      if (!this.data.length) {
        return;
      }
      var json = this.getProcessedJson(this.data, this.downloadFields());
      if (this.type == 'csv') {
        return this.export(this.jsonToCSV(json), this.name, 'application/csv');
      }
      return this.export(this.jsonToXLS(json), this.name, 'application/vnd.ms-excel');
    }
  }, {
    key: 'export',
    value: function _export(data, filename, mime) {
      var blob = this.base64ToBlob(data, mime);
      (0, _downloadjs2.default)(blob, filename, mime);
    }
  }, {
    key: 'jsonToXLS',
    value: function jsonToXLS(data) {
      var xlsTemp = '<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel" xmlns="http://www.w3.org/TR/REC-html40"><head><meta name=ProgId content=Excel.Sheet> <meta name=Generator content="Microsoft Excel 11"><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>{worksheet}</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--></head><body><table>${table}</table></body></html>';
      var xlsData = '<thead><tr>';
      var colspan = (0, _keys2.default)(data[0]).length;

      if (this.title != null) {
        xlsData += this.parseExtraData(this.title, '<th colspan="' + colspan + '">${data}<th></tr><tr>');
      }

      for (var key in data[0]) {
        xlsData += '<th>' + key + '</th>';
      }
      xlsData += '</tr></thead>';
      xlsData += '<tbody>';

      data.map(function (item, index) {
        xlsData += '<tbody><tr>';
        for (var _key in item) {
          xlsData += '<td>' + item[_key] + '</td>';
        }
        xlsData += '</tr></tbody>';
      });

      if (this.footer != null) {
        xlsData += '<tfooter><tr>';
        xlsData += this.parseExtraData(this.footer, '<td colspan="' + colspan + '">${data}<td></tr><tr>');
        xlsData += '</tr></tfooter>';
      }
      return xlsTemp.replace('${table}', xlsData);
    }
  }, {
    key: 'jsonToCSV',
    value: function jsonToCSV(data) {
      var csvData = '';

      if (this.title != null) {
        csvData += this.parseExtraData(this.title, '${data}\r\n');
      }

      for (var key in data[0]) {
        csvData += key + ',';
      }
      csvData = csvData.slice(0, csvData.length - 1);
      csvData += '\r\n';

      data.map(function (item) {
        for (var _key2 in item) {
          var escapedCSV = item[_key2] + '';
          if (escapedCSV.match(/[,"\n]/)) {
            escapedCSV = '"' + escapedCSV.replace(/\"/g, '""') + '"';
          }
          csvData += escapedCSV + ',';
        }
        csvData = csvData.slice(0, csvData.length - 1);
        csvData += '\r\n';
      });

      if (this.footer != null) {
        csvData += this.parseExtraData(this.footer, '${data}\r\n');
      }
      return csvData;
    }
  }, {
    key: 'getProcessedJson',
    value: function getProcessedJson(data, header) {
      var keys = this.getKeys(data, header);
      var newData = [];
      var _self = this;
      data.map(function (item, index) {
        var newItem = {};
        for (var label in keys) {
          var iii = item;
          var property = keys[label];
          newItem[label] = _self.getNestedData(property, item);
        }
        newData.push(newItem);
      });

      return newData;
    }
  }, {
    key: 'getKeys',
    value: function getKeys(data, header) {
      if (header) {
        return header;
      }

      var keys = {};
      for (var key in data[0]) {
        keys[key] = key;
      }
      return keys;
    }
  }, {
    key: 'parseExtraData',
    value: function parseExtraData(extraData, format) {
      var parseData = '';
      if (Array.isArray(extraData)) {
        for (var i = 0; i < extraData.length; i++) {
          parseData += format.replace('${data}', extraData[i]);
        }
      } else {
        parseData += format.replace('${data}', extraData);
      }
      return parseData;
    }
  }, {
    key: 'callItemCallback',
    value: function callItemCallback(field, itemValue) {
      if ((typeof field === 'undefined' ? 'undefined' : (0, _typeof3.default)(field)) === 'object' && typeof field.callback === 'function') {
        return field.callback(itemValue);
      }
      return itemValue;
    }
  }, {
    key: 'getNestedData',
    value: function getNestedData(key, item) {
      var field = (typeof key === 'undefined' ? 'undefined' : (0, _typeof3.default)(key)) === 'object' ? key.field : key;

      var valueFromNestedKey = null;
      var keyNestedSplit = field.split('.');

      valueFromNestedKey = item[keyNestedSplit[0]];
      for (var j = 1; j < keyNestedSplit.length; j++) {
        valueFromNestedKey = valueFromNestedKey[keyNestedSplit[j]];
      }

      valueFromNestedKey = this.callItemCallback(key, valueFromNestedKey);

      return valueFromNestedKey;
    }
  }, {
    key: 'base64ToBlob',
    value: function base64ToBlob(data, mime) {
      var base64 = window.btoa(window.unescape(encodeURIComponent(data)));
      var bstr = atob(base64);
      var n = bstr.length;
      var u8arr = new Uint8ClampedArray(n);
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
      }
      return new Blob([u8arr], { type: mime });
    }
  }]);
  return Json2Excel;
}();

exports.default = Json2Excel;